// QtzCoeffView.cpp : CQtzCoeffView NX̓̒`s܂B
// by Toshio Iwata at digitalfilter.com 2004/09/16

#include "stdafx.h"
#include "QtzCoeff.h"

#include "QtzCoeffDoc.h"
#include "QtzCoeffView.h"
#include "DlgQtz.h"
#include "DlgCoFmt.h"
#include "DlgBitAdjust.h"
#include "DlgRng.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CQtzCoeffView

IMPLEMENT_DYNCREATE(CQtzCoeffView, CView)

BEGIN_MESSAGE_MAP(CQtzCoeffView, CView)
	//{{AFX_MSG_MAP(CQtzCoeffView)
	ON_COMMAND(ID_MENU_COLD, OnMenuCold)
	ON_COMMAND(ID_MENU_QTZ, OnMenuQtz)
	ON_COMMAND(ID_MENU_SV, OnMenuSv)
	ON_COMMAND(ID_MENU_RANGE, OnMenuRange)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQtzCoeffView NX̍\z/

CQtzCoeffView::CQtzCoeffView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	int i;
	for( i = 0; i < 400; i++ ) hh[i] = 0.0;
	ShiftBit = FALSE;
	TapN = 10;
	coeff_range = 1.0;
	BITS = 6;
	QTZ = FALSE;
	CoeffFmt = 0;
	coeff_loaded = FALSE;
	costart = 0;
}

CQtzCoeffView::~CQtzCoeffView()
{
}

BOOL CQtzCoeffView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CQtzCoeffView NX̕`

void CQtzCoeffView::OnDraw(CDC* pDC)
{
	CQtzCoeffDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	if(coeff_loaded) {
		CoeffDraw(pDC, 100, 160);
	} else {
		pDC->TextOut( 50, 50, "QtzCoeff.exe");
		pDC->TextOut( 50, 80, "tB^̌Wǂݍŗʎq܂B");
		pDC->TextOut( 50, 110, "uWvuWǂݍ݁vIĂB");
		pDC->TextOut( 50, 140, "by DIGITALFILTER.COM");
	}
}

/////////////////////////////////////////////////////////////////////////////
// CQtzCoeffView NẌ

BOOL CQtzCoeffView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CQtzCoeffView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CQtzCoeffView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CQtzCoeffView NX̐ff

#ifdef _DEBUG
void CQtzCoeffView::AssertValid() const
{
	CView::AssertValid();
}

void CQtzCoeffView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CQtzCoeffDoc* CQtzCoeffView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CQtzCoeffDoc)));
	return (CQtzCoeffDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CQtzCoeffView NX̃bZ[W nh

void CQtzCoeffView::OnMenuCold() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CFileDialog dlgF(TRUE, NULL, filecoeffld);
	//1FOPEN̂ƂTRUE
	//2,3Ft@C̎
	FILE *ifp;
	float doubleline;
	int linecount;
	int i;
			
	if( dlgF.DoModal() == IDOK)	{
		filecoeffld = dlgF.GetPathName();
		//filenameɑIt@C̃tpX
		ifp = fopen( filecoeffld, "r" );
		//ȍ~Ƀt@Cf[^ǂݍ
		if (ifp != NULL) {
			fseek( ifp, 0L, SEEK_SET );
			for (i = 0; i < 400; i++) hh[i] = 0.0;
			linecount = 0;
			while( fscanf(ifp, "%f", &doubleline) != EOF ) {
				hh[linecount] = doubleline;
				linecount++;
				if( linecount == 400 ) {
					break;
				} 
			} 
			TapN = linecount;
			coeff_loaded = TRUE;
			fclose( ifp );
			InvalidateRect(NULL, TRUE);
		}
	}
}

void CQtzCoeffView::CoeffDraw(CDC *pDC, int x0, int y0)
{
	CPen	myPen;
	CPen*	pOldPen;

	int i;
	int xscale = 400;
	int yscale = 100;
	double inw_tmp[100];
	char mgt_char[15];

	for (i = costart; i < costart + 100; i++) {
		if( !QTZ ) inw_tmp[i-costart] = hh[i];
		else inw_tmp[i-costart] = Quantize(hh[i]);
	}

	for (i = 0; i < 100; i++) {
		inw_tmp[i] = 100 * inw_tmp[i] * 1.0 / coeff_range;
		if( inw_tmp[i] > yscale ) inw_tmp[i] = yscale;
		if( inw_tmp[i] < -yscale ) inw_tmp[i] = -yscale;
	}

	pDC->MoveTo(x0, y0 - yscale);
	pDC->LineTo(x0 + xscale, y0 - yscale);
	pDC->MoveTo(x0, y0 + yscale);
	pDC->LineTo(x0 + xscale, y0 + yscale);

	pDC->MoveTo(x0, y0 - yscale);
	pDC->LineTo(x0, y0 + yscale);
	pDC->MoveTo(x0 + xscale, y0 - yscale);
	pDC->LineTo(x0 + xscale, y0 + yscale);

	myPen.CreatePen(PS_DOT, 1, RGB(100, 100, 100));
	pOldPen = pDC->SelectObject(&myPen);

	pDC->MoveTo(x0, y0 - yscale/2);
	pDC->LineTo(x0 + xscale, y0 - yscale/2);
	pDC->MoveTo(x0, y0 + yscale/2);
	pDC->LineTo(x0 + xscale, y0 + yscale/2);
	pDC->MoveTo(x0, y0);
	pDC->LineTo(x0 + xscale, y0);

	pDC->MoveTo(x0 + xscale*1/4, y0 - yscale);
	pDC->LineTo(x0 + xscale*1/4, y0 + yscale);
	pDC->MoveTo(x0 + xscale*2/4, y0 - yscale);
	pDC->LineTo(x0 + xscale*2/4, y0 + yscale);
	pDC->MoveTo(x0 + xscale*3/4, y0 - yscale);
	pDC->LineTo(x0 + xscale*3/4, y0 + yscale);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	myPen.CreatePen(PS_SOLID, 1, RGB(200,0,255));
	pOldPen = pDC->SelectObject(&myPen);

	int xstep = 4;
	for(i = 0; i < 100-1; i++) {
		pDC->MoveTo(x0 + (i  ) * xstep, y0 + (int)((-1) * inw_tmp[i]));
		pDC->LineTo(x0 + (i+1) * xstep, y0 + (int)((-1) * inw_tmp[i+1]));
	} 

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	pDC->TextOut(x0 - 10, y0 + yscale + 10, "h[0]");
	pDC->TextOut(x0 + xscale/2 - 10, y0 + yscale + 10, "h[50]");
	pDC->TextOut(x0 + xscale - 10, y0 + yscale + 10, "h[99]");

	sprintf(mgt_char,"%6.3f", coeff_range);
	pDC->TextOut(x0 - 50, y0 - yscale - 10, mgt_char);
	sprintf(mgt_char,"%6.3f", coeff_range/2);
	pDC->TextOut(x0 - 50, y0 - yscale/2 - 10, mgt_char);
	sprintf(mgt_char,"-%6.3f", coeff_range);
	pDC->TextOut(x0 - 60, y0 + yscale - 10, mgt_char);
	sprintf(mgt_char,"-%6.3f", coeff_range/2);
	pDC->TextOut(x0 - 60, y0 + yscale/2 - 10, mgt_char);
	pDC->TextOut(x0 - 45, y0 - 10, "0.00");

}

void CQtzCoeffView::OnMenuQtz() 
{
	CDlgQtz dlg;

	dlg.m_qtz = QTZ;
	dlg.m_bits = BITS;
	if (dlg.DoModal() == IDOK) {
		QTZ = dlg.m_qtz;
		BITS = dlg.m_bits;
		if( QTZ && ScanAbs() >= 1.0 ) {
			CDlgBitAdjust dlg;
			if (dlg.DoModal() == IDOK) {
			}	
			ShiftBit = TRUE;
		} else {
			ShiftBit = FALSE;
		}
		InvalidateRect(NULL, TRUE);
	}				
}

void CQtzCoeffView::OnMenuSv() 
{
	CDlgCoFmt dlg;

	dlg.m_real0 = CoeffFmt;
	if (dlg.DoModal() == IDOK) {
		CoeffFmt = dlg.m_real0;		
		SaveCoeff();
		InvalidateRect(NULL, TRUE);
	}				
}

void CQtzCoeffView::SaveCoeff()
{
	FILE *fpo;
	double tmpdouble;
	long tmplong;
	char* tmpchar;

	CFileDialog dlgF(FALSE, NULL, "coeff1.txt");
	if( dlgF.DoModal() == IDOK)	{
		//filenameɑIt@C̃tpX
		filecoeffsv = dlgF.GetPathName();
		fpo = fopen( filecoeffsv, "w" );
		//ȍ~t@CɃf[^
		if (fpo != NULL) { 
			if( !QTZ ) {
				for( int i = 0; i < TapN; i++ ) {
					tmpdouble = hh[i];
				}
			} else if( CoeffFmt == 0 ) { // 
				for( int i = 0; i < TapN; i++ ) {
					tmpdouble = Quantize(hh[i]);
					fprintf(fpo, "%12.7f\n", tmpdouble);
				}
			} else if( CoeffFmt == 1 ) { // 10i
				for( int i = 0; i < TapN; i++ ) {
					if(!ShiftBit) tmplong = Quantize_long(hh[i]);
					else tmplong = Quantize_long(hh[i] / 4.0);
					fprintf(fpo, "%12d\n", tmplong);
				}
			} else if( CoeffFmt == 2 ) { // 2i
				for( int i = 0; i < TapN; i++ ) {
					if(!ShiftBit) tmplong = Quantize_long(hh[i]);
					else tmplong = Quantize_long(hh[i] / 4.0);
					tmpchar = Long2Bin(tmplong, FALSE);
					fprintf(fpo, "%s\n", tmpchar);
				}
			} else if( CoeffFmt == 3 ) { // 16i
				for( int i = 0; i < TapN; i++ ) {
					if(!ShiftBit) tmplong = Quantize_long(hh[i]);
					else tmplong = Quantize_long(hh[i] / 4.0);
					tmpchar = Long2Hex(tmplong);
					fprintf(fpo, "%s\n", tmpchar);
				}
			}
		}
		fclose(fpo);
	} 
	InvalidateRect(NULL, TRUE);	
}

double CQtzCoeffView::Quantize(double Din)
{
	double aa, bb, dd;
	long cc;
	double k2 = 1.0;
	int i;

	for ( i = 0; i < BITS-1; i++ ) { // MSB͕rbg
		k2 = k2 * 2.0;
	}

	aa = k2 * Din;
	bb = aa + 0.0; // ۂ߂̏ꍇ+0.5
	cc = (long)bb;
	dd = cc / k2;

	return dd;
}

long CQtzCoeffView::Quantize_long(double Din)
{
	double aa, bb;
	long cc;
	double k2 = 1.0;
	int i;

	for ( i = 0; i < BITS-1; i++ ) { // MSB͕rbg
		k2 = k2 * 2.0;
	}

	aa = k2 * Din;
	bb = aa + 0.0; // ۂ߂̏ꍇ+0.5
	cc = (long)bb;

	return cc;
}

char* CQtzCoeffView::Long2Bin(long Din, BOOL plus2bits)
{
	char* Outchar = new char[34];
	int k2 = 2;
	int mods = 0;
	int i, k;
	long divs;

	divs = Din;

	if( divs >= 0 ) {
		for ( k = 0; k < 34; k++ ) Outchar[k] = NULL;
		if( plus2bits ) { 
			for ( k = 0; k < BITS+2; k++ ) Outchar[k] = '0';
			i = BITS + 2 - 1;
		} else { 
			for ( k = 0; k < BITS; k++ ) Outchar[k] = '0';
			i = BITS - 1;
		}
		while (divs != 0) {
			mods = divs % k2;
			divs = (divs - mods) / k2;
			switch( mods ) {
				case 0: Outchar[i] = '0'; break;
				case 1:	Outchar[i] = '1'; break;
			}
			i--;
		}
	} else {
		divs = divs * (-1) - 1;
		for ( k = 0; k < 34; k++ ) Outchar[k] = NULL;
		if( plus2bits ) {
			for ( k = 0; k < BITS+2; k++ ) Outchar[k] = '1';
			i = BITS + 2 - 1; 
		} else { 
			for ( k = 0; k < BITS; k++ ) Outchar[k] = '1';
			i = BITS - 1;
		}
		while (divs != 0) {
			mods = divs % k2;
			divs = (divs - mods) / k2;
			switch( mods ) {
				case 0: Outchar[i] = '1'; break;
				case 1:	Outchar[i] = '0'; break;
			}
			i--;
		}
	}
	return Outchar;
	delete[] Outchar;
}

char* CQtzCoeffView::Long2Hex(long Din)
{
	char* Outchar = new char[10];
	int k16 = 16;
	int mods = 0;
	int i, k;
	long divs;
	divs = Din;

	if( divs >= 0 ) {
		for(k = 0; k < 10; k++) Outchar[k] = NULL;
		for(k = 0; k < 8; k++) Outchar[k] = '0';
		i = 7;
		while (divs != 0) {
			mods = divs % k16;
			divs = (divs - mods) / k16;
			switch( mods ) {
				case 0: Outchar[i] = '0'; break;
				case 1:	Outchar[i] = '1'; break;
				case 2:	Outchar[i] = '2'; break;
				case 3:	Outchar[i] = '3'; break;
				case 4:	Outchar[i] = '4'; break;
				case 5:	Outchar[i] = '5'; break;
				case 6:	Outchar[i] = '6'; break;
				case 7: Outchar[i] = '7'; break;
				case 8: Outchar[i] = '8'; break;
				case 9:	Outchar[i] = '9'; break;
				case 10: Outchar[i] = 'A'; break;
				case 11: Outchar[i] = 'B'; break;
				case 12: Outchar[i] = 'C'; break;
				case 13: Outchar[i] = 'D'; break;
				case 14: Outchar[i] = 'E'; break;
				case 15: Outchar[i] = 'F'; break;
			}
			i--;
		} 
	} else {
		for(k = 0; k < 10; k++) Outchar[k] = NULL;
		for(k = 0; k < 8; k++) Outchar[k] = 'F';
		divs = divs * (-1) - 1;
		i = 7;
		while (divs != 0) {
			mods = divs % k16;
			divs = (divs - mods) / k16;
			switch( mods ) {
				case 0: Outchar[i] = 'F'; break;
				case 1:	Outchar[i] = 'E'; break;
				case 2:	Outchar[i] = 'D'; break;
				case 3:	Outchar[i] = 'C'; break;
				case 4:	Outchar[i] = 'B'; break;
				case 5:	Outchar[i] = 'A'; break;
				case 6:	Outchar[i] = '9'; break;
				case 7: Outchar[i] = '8'; break;
				case 8: Outchar[i] = '7'; break;
				case 9:	Outchar[i] = '6'; break;
				case 10: Outchar[i] = '5'; break;
				case 11: Outchar[i] = '4'; break;
				case 12: Outchar[i] = '3'; break;
				case 13: Outchar[i] = '2'; break;
				case 14: Outchar[i] = '1'; break;
				case 15: Outchar[i] = '0'; break;
			}
			i--;
		} 
	} 
	return Outchar;
	delete[] Outchar;
}

// Scan absolute values
double CQtzCoeffView::ScanAbs()
{
	int i;
	double maxabs = 0.0;

	for (i = 0; i < TapN; i++) {
		if(maxabs < fabs(hh[i])) maxabs = fabs(hh[i]);
	}
	return maxabs;
}

void CQtzCoeffView::OnMenuRange() 
{
	CDlgRng dlg;

	dlg.m_comax = coeff_range;
	dlg.m_costart = costart;
	if (dlg.DoModal() == IDOK) {
		coeff_range = dlg.m_comax; 
		costart = dlg.m_costart; 
		InvalidateRect(NULL, TRUE);
	}	
}

void CQtzCoeffView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CRect rectClient;
	GetClientRect(&rectClient);
	pDC -> SetMapMode(MM_ANISOTROPIC);
	pDC -> SetWindowOrg(0,0);
	pDC -> SetWindowExt(100,50);
	pDC -> SetViewportOrg(0,0);
	pDC -> SetViewportExt(550, 350); // `TCYݒ

	CFont* pfontCurrent = pDC -> GetCurrentFont();
	LOGFONT lfCurrentFont;
	pfontCurrent -> GetObject(sizeof(LOGFONT), &lfCurrentFont);
	CFont fontBig;
	lfCurrentFont.lfHeight = 12; // tHgTCYijݒ
	lfCurrentFont.lfWidth = 6; // tHgTCYijݒ

	fontBig.CreateFontIndirect(&lfCurrentFont);
	CFont* defaultFont = (CFont*)pDC -> SelectObject(&fontBig);

	CView::OnPrint(pDC, pInfo);
}
